/************************************************************\
*
\************************************************************/
function prs_hexdec(str)
{
    return parseInt(str,16);
}

/************************************************************\
*
\************************************************************/
function prs_zeroFill(a,b)
{
    var z = prs_hexdec(80000000);
    if (z & a)
    {
        a = a>>1;
        a &= ~z;
        a |= 0x40000000;
        a = a>>(b-1);
    }
    else
    {
        a = a >> b;
    }
    return (a);
}

/************************************************************\
*
\************************************************************/
function prs_mix(a,b,c)
{
    a -= b; a -= c; a ^= (prs_zeroFill(c,13));
    b -= c; b -= a; b ^= (a<<8);
    c -= a; c -= b; c ^= (prs_zeroFill(b,13));
    a -= b; a -= c; a ^= (prs_zeroFill(c,12));
    b -= c; b -= a; b ^= (a<<16);
    c -= a; c -= b; c ^= (prs_zeroFill(b,5));
    a -= b; a -= c; a ^= (prs_zeroFill(c,3));
    b -= c; b -= a; b ^= (a<<10);
    c -= a; c -= b; c ^= (prs_zeroFill(b,15));
    var ret = new Array((a),(b),(c));
    return ret;
}

/************************************************************\
*
\************************************************************/
function prs_GoogleCH(url,length)
{
    var init = 0xE6359A60;
    if (arguments.length == 1)
      length = url.length;
    var a = 0x9E3779B9;
    var b = 0x9E3779B9;
    var c = 0xE6359A60;
    var k = 0;
    var len = length;
    var mixo = new Array();
    while(len >= 12)
    {
        a += (url[k+0] +(url[k+1]<<8) +(url[k+2]<<16) +(url[k+3]<<24));
        b += (url[k+4] +(url[k+5]<<8) +(url[k+6]<<16) +(url[k+7]<<24));
        c += (url[k+8] +(url[k+9]<<8) +(url[k+10]<<16)+(url[k+11]<<24));
        mixo = prs_mix(a,b,c);
        a = mixo[0]; b = mixo[1]; c = mixo[2];
        k += 12;
        len -= 12;
    }
    c += length;
    switch(len)
    {
        case 11:
        c += url[k+10]<<24;
        case 10:
        c+=url[k+9]<<16;
        case 9 :
        c+=url[k+8]<<8;
        case 8 :
        b+=(url[k+7]<<24);
        case 7 :
        b+=(url[k+6]<<16);
        case 6 :
        b+=(url[k+5]<<8);
        case 5 :
        b+=(url[k+4]);
        case 4 :
        a+=(url[k+3]<<24);
        case 3 :
        a+=(url[k+2]<<16);
        case 2 :
        a+=(url[k+1]<<8);
        case 1 :
        a+=(url[k+0]);
    }
    mixo = prs_mix(a,b,c);
    if (mixo[2] < 0)
    return (0x100000000 + mixo[2]);
    else
    return mixo[2];
}

/************************************************************\
*
\************************************************************/
function prs_strord(string)
{
    var result = new Array();
    for(i=0;i<string.length;i++)
    {
        result[i] = string[i].charCodeAt(0);
    }
    return result;
}
/************************************************************\
*
\************************************************************/
function prs_c32to8bit(arr32)
{
    var arr8 = new Array();
    for(i=0;i<arr32.length;i++)
    {
      for (bitOrder=i*4;bitOrder<=i*4+3;bitOrder++)
      {
            arr8[bitOrder]=arr32[i]&255;
            arr32[i]=prs_zeroFill(arr32[i], 8);
        }
    }
    return arr8;
}
/************************************************************\
*
\************************************************************/
function prs_myfmod(x,y)
{
   var i = Math.floor(x/y);
        return (x - i*y);
}

/************************************************************\
*
\************************************************************/
function prs_GoogleNewCh(ch)
{
   ch = (((ch/7) << 2) | ((prs_myfmod(ch,13))&7));

   prbuf = new Array();
   prbuf[0] = ch;
   for(i = 1; i < 20; i++) {
            prbuf[i] = prbuf[i-1]-9;
   }
   ch = prs_GoogleCH(prs_c32to8bit(prbuf), 80);
   return ch;

}

var gPRS_XMLHttpRequest;
var gPRS_lastpr;
var gPRS_lastcat;
var gPRS_lasturl;
var gPRS_prcache = new Array();
var gPRS_prcachena = new Array();
var gPRS_catcache = new Array();
var gPRS_isnewurl = 0;
var gPRS_ch = 0;
var gPRS_state = 1;
var gPRS_odpurl = 'http://directory.google.com/Top/'; //ODP URL
//var gPRS_odpurl = 'http://dir.thumbshots.net/?trigger=http://dmoz.org/';
//var gPRS_odpurl = 'http://dmoz.org/';



/************************************************************\
*
\************************************************************/
function prs_isnewurl(hash)
{
    var i=0;
    var trouve=-1;
    while (trouve==-1 && (i < gPRS_prcache.length))
    {
   //dump("isnewurl: " + gPRS_prcache[i][0] + " <?> " + hash + "\n");
        if (gPRS_prcache[i][0] == hash)
        {
            trouve = i;
       break;
        }
        i++;
    }
    return trouve;
}

function prs_isnewurlna(hash)
{
    var i=0;
    var trouve=-1;

    while (trouve==-1 && (i < gPRS_prcachena.length))
    {
        //dump("isnewurl: " + gPRS_prcachena[i][0] + " <?> " + hash + "\n");
        if (gPRS_prcachena[i][0] == hash)
        {
            trouve = i;
            break;
        }
        i++;
    }

   //dump(trouve + "\n");
    return trouve;
}

/************************************************************\
*
\************************************************************/
function setPagerankStatus()
{
    var pagerank = document.getElementById('pagerank-status');
    var tooltip = document.getElementById('pagerank-tooltip-value');
    var temp = gPRS_XMLHttpRequest.responseText;
    var foo = temp.match(/Rank_.*?:.*?:(\d+)/i);

    var pr = (foo) ? foo[1] : "-1";
    foo = temp.match(/A_.*?:.*?:(?:Top\/)?([^\s]+)/i);
    var cat = (foo) ? foo[1] : "n/a";
   var iscat = (cat=="n/a") ? "" : "cat";

    pagerank.setAttribute("status", iscat+pr);
    tooltip.setAttribute("value", cat);
    gPRS_lastpr = pr;
    gPRS_lastcat = cat;
   if (gPRS_lastpr != -1)
   {
       gPRS_prcache.push(new Array(gPRS_ch,gPRS_lastpr));
       gPRS_catcache.push(new Array(gPRS_ch,gPRS_lastcat));
   //dump("pushed: " + gPRS_ch + "," + gPRS_lastpr +"\n");
   }
   else
   {
      gPRS_prcachena.push(new Array(gPRS_ch,gPRS_lastpr));
   }
}

/************************************************************\
*
\************************************************************/
/*function prs_URLencode(sStr) {
    return escape(sStr).replace(/\+/g, '%2B').replace(/[ ]/g,'+').replace(/\//g,'%2F').replace(/~/g,'%7E');
}
*/
function prs_URLencode(sStr)
{
return encodeURIComponent(sStr).replace(/\+/g,"%2B").replace(/\//g,"%2F");
}
/************************************************************\
*
\************************************************************/
function initPagerankStatus()
{
    var pagerank = document.getElementById('pagerank-status');
    var tooltip = document.getElementById('pagerank-tooltip-value');

    var url = new String(window._content.document.location);
    url = url.replace(/\?.*$/g,'?');

    var reqgr = "info:" + url;
    var reqgre = "info:" + prs_URLencode(url);
    gPRS_ch = prs_GoogleCH(prs_strord(reqgr));
    gPRS_ch = "6" + prs_GoogleNewCh(gPRS_ch);
   //dump("gPRS_ch=" + gPRS_ch + "\n");

    var querystring = "http://toolbarqueries.google.com/search?client=navclient-auto&ch=" + gPRS_ch + "&features=Rank&q=" + reqgre;
    var patern = /^http:/;
    var patern2 = /^http:\/\/.*google\..*\/(search|images|groups|news).*/;
    var patern3 = /^http:\/\/localhost.*/;
    var patern4 = /^http:\/\/(127\.|10\.|172\.16|192\.168).*/; //local ip

    if (gPRS_state == 0)
    {
        //pagerank.setAttribute("status", "disabled");
        //tooltip.setAttribute("value", "Disabled");
    }
    else if (!patern.test(url) || patern2.test(url)
    || patern3.test(url) || patern4.test(url))
    {
        pagerank.setAttribute("status","");
        tooltip.setAttribute("value", "n/a");
        gPRS_lastpr = -1;
    }
    else if ((gPRS_isnewurl = prs_isnewurl(gPRS_ch)) >= 0)
    {
   //dump("cached: " + gPRS_prcache[gPRS_isnewurl][1] + " | " + gPRS_catcache[gPRS_isnewurl][1] + " | ");
        gPRS_lastpr = gPRS_prcache[gPRS_isnewurl][1];
        gPRS_lastcat = gPRS_catcache[gPRS_isnewurl][1];
   var iscat = (gPRS_lastcat=="n/a") ? "" : "cat";
   //dump("iscat : " + iscat + " | " + iscat+gPRS_lastpr);
        pagerank.setAttribute("status",iscat+gPRS_lastpr);
        tooltip.setAttribute("value", gPRS_lastcat);
    }
    else if ((gPRS_isnewurl = prs_isnewurlna(gPRS_ch)) >=0)
    {
        gPRS_lastpr = gPRS_prcachena[gPRS_isnewurl][1];
        pagerank.setAttribute("status",gPRS_lastpr);
        tooltip.setAttribute("value", "n/a");

    }
    else
    {

        gPRS_XMLHttpRequest = new XMLHttpRequest();
        gPRS_XMLHttpRequest.onload = setPagerankStatus;
        gPRS_XMLHttpRequest.open("GET", querystring);
        //gPRS_XMLHttpRequest.setRequestHeader("User-Agent","Mozilla/4.0 (compatible; GoogleToolbar 2.0.114-big; Windows XP 5.1)");
        gPRS_XMLHttpRequest.send(null);
    }
    gPRS_lasturl = url;

}

/************************************************************\
*
\************************************************************/
function resetPagerankStatus()
{

    var pagerank = document.getElementById('pagerank-status');
    var tooltip = document.getElementById('pagerank-tooltip-value');
    var url = new String(window._content.document.location);

    url = url.replace(/\?.*$/g,'?');
    if (gPRS_state == 0)
    {
        pagerank.setAttribute("status", "disabled");
        tooltip.setAttribute("value", "Disabled");
    }
    else if (url == gPRS_lasturl)
    {
         var iscat = (gPRS_lastcat=="n/a"||gPRS_lastpr==-1) ? "" : "cat";

      pagerank.setAttribute("status", iscat+gPRS_lastpr);
        if (gPRS_lastpr == -1)
        tooltip.setAttribute("value", "n/a");
        else
        tooltip.setAttribute("value", gPRS_lastcat);
    }
    else
    {
        gPRS_lasturl = url;
        initPagerankStatus();
    }
}

/************************************************************\
*
\************************************************************/
function switchpagerankstatusstate(event)
{
    const LEFT = 0, RIGHT = 2;
    var tooltip = document.getElementById('pagerank-tooltip-value');
    var pagerank = document.getElementById('pagerank-status');

    if (event.button==RIGHT)
    {
        if (gPRS_state == 0)
        {
            gPRS_prefService.setIntPref("pagerankstatuspref.state", 1);
            gPRS_state = 1;
            initPagerankStatus();
        }
        else
        {
            gPRS_prefService.setIntPref("pagerankstatuspref.state", 0);
            gPRS_state = 0;
            pagerank.setAttribute("status", "disabled");
            tooltip.setAttribute("value", "Disabled");
        }
    }
    else if (event.button==LEFT && gPRS_state==1)
    {
        var gtempcat = tooltip.getAttribute("value");
//        var foo = temp.match(/Category: ([^\s]+)/i);
//        var gtempcat = (foo) ? foo[1] : "";
        gtempcat = (gtempcat=="n/a"||gtempcat=="Disabled") ? "" : gtempcat;
        if (gtempcat)
        {
            //open category page...
            var newTab = getBrowser().addTab(gPRS_odpurl + encodeURI(gtempcat + "/"));
            getBrowser().selectedTab = newTab;
        }
    }
}

// prefs
var gPRS_prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
if(!gPRS_prefService.prefHasUserValue("pagerankstatuspref.state"))
{
    gPRS_prefService.setIntPref("pagerankstatuspref.state", 1);
}
if(!gPRS_prefService.prefHasUserValue("pagerankstatuspref.odpurl"))
{
    gPRS_prefService.setCharPref("pagerankstatuspref.odpurl", 'http://directory.google.com/Top/');
}
gPRS_state = gPRS_prefService.getIntPref("pagerankstatuspref.state");
gPRS_odpurl = gPRS_prefService.getCharPref("pagerankstatuspref.odpurl");
window.addEventListener("load",function() {initPagerankStatus();},true);
window.addEventListener("focus",function() {resetPagerankStatus();},true);

//***********
//debug  dump() to stdout (firefox -console)?
/*
const PREFS_CID      = "@mozilla.org/preferences;1";
const PREFS_I_PREF   = "nsIPref";
const PREF_STRING    = "browser.dom.window.dump.enabled";
try {
        var Pref        = new Components.Constructor(PREFS_CID, PREFS_I_PREF);
        var pref        = new Pref( );
        pref.SetBoolPref(PREF_STRING, true);
} catch(e) {} */
//************

