/************************************************************\
*
\************************************************************/
function hexdec(str)
{
    return parseInt(str,16);
}

/************************************************************\
*
\************************************************************/
function zeroFill(a,b)
{
    var z = hexdec(80000000);
    if (z & a)
    {
        a = a>>1;
        a &= ~z;
        a |= 0x40000000;
        a = a>>(b-1);
    }
    else
    {
        a = a >> b;
    }
    return (a);
}

/************************************************************\
*
\************************************************************/
function mix(a,b,c)
{
    a -= b; a -= c; a ^= (zeroFill(c,13));
    b -= c; b -= a; b ^= (a<<8);
    c -= a; c -= b; c ^= (zeroFill(b,13));
    a -= b; a -= c; a ^= (zeroFill(c,12));
    b -= c; b -= a; b ^= (a<<16);
    c -= a; c -= b; c ^= (zeroFill(b,5));
    a -= b; a -= c; a ^= (zeroFill(c,3));
    b -= c; b -= a; b ^= (a<<10);
    c -= a; c -= b; c ^= (zeroFill(b,15));
    var ret = new Array((a),(b),(c));
    return ret;
}

/************************************************************\
*
\************************************************************/
function GoogleCH(url,length)
{
    var init = 0xE6359A60;
    if (arguments.length == 1)
      length = url.length;
    var a = 0x9E3779B9;
    var b = 0x9E3779B9;
    var c = 0xE6359A60;
    var k = 0;
    var len = length;
    var mixo = new Array();
    while(len >= 12)
    {
        a += (url[k+0] +(url[k+1]<<8) +(url[k+2]<<16) +(url[k+3]<<24));
        b += (url[k+4] +(url[k+5]<<8) +(url[k+6]<<16) +(url[k+7]<<24));
        c += (url[k+8] +(url[k+9]<<8) +(url[k+10]<<16)+(url[k+11]<<24));
        mixo = mix(a,b,c);
        a = mixo[0]; b = mixo[1]; c = mixo[2];
        k += 12;
        len -= 12;
    }
    c += length;
    switch(len)
    {
        case 11:
        c += url[k+10]<<24;
        case 10:
        c+=url[k+9]<<16;
        case 9 :
        c+=url[k+8]<<8;
        case 8 :
        b+=(url[k+7]<<24);
        case 7 :
        b+=(url[k+6]<<16);
        case 6 :
        b+=(url[k+5]<<8);
        case 5 :
        b+=(url[k+4]);
        case 4 :
        a+=(url[k+3]<<24);
        case 3 :
        a+=(url[k+2]<<16);
        case 2 :
        a+=(url[k+1]<<8);
        case 1 :
        a+=(url[k+0]);
    }
    mixo = mix(a,b,c);
    if (mixo[2] < 0)
    return (0x100000000 + mixo[2]);
    else
    return mixo[2];
}

/************************************************************\
*
\************************************************************/
function strord(string)
{
    var result = new Array();
    for(i=0;i<string.length;i++)
    {
        result[i] = string[i].charCodeAt(0);
    }
    return result;
}
/************************************************************\
*
\************************************************************/
function c32to8bit(arr32)
{
    var arr8 = new Array();
    for(i=0;i<arr32.length;i++)
    {
      for (bitOrder=i*4;bitOrder<=i*4+3;bitOrder++)
      {
            arr8[bitOrder]=arr32[i]&255;
            arr32[i]=zeroFill(arr32[i], 8);
        }
    }
    return arr8;
}
/************************************************************\
*
\************************************************************/
function myfmod(x,y)
{
   var i = Math.floor(x/y);
        return (x - i*y);
}

/************************************************************\
*
\************************************************************/
function GoogleNewCh(ch)
{
   ch = (((ch/7) << 2) | ((myfmod(ch,13))&7));

   prbuf = new Array();
   prbuf[0] = ch;
   for(i = 1; i < 20; i++) {
            prbuf[i] = prbuf[i-1]-9;
   }
   ch = GoogleCH(c32to8bit(prbuf), 80);
   return ch;

}

var gXMLHttpRequest;
var glastpr;
var glastcat;
var glasturl;
var gprcache = new Array();
var gprcachena = new Array();
var gcatcache = new Array();
var gisnewurl = 0;
var gch = 0;
var gstate = 1;
var godpurl = 'http://directory.google.com/Top/'; //ODP URL
//var godpurl = 'http://dir.thumbshots.net/?trigger=http://dmoz.org/';
//var godpurl = 'http://dmoz.org/';



/************************************************************\
*
\************************************************************/
function isnewurl(hash)
{
    var i=0;
    var trouve=-1;
    while (trouve==-1 && (i < gprcache.length))
    {
   //dump("isnewurl: " + gprcache[i][0] + " <?> " + hash + "\n");
        if (gprcache[i][0] == hash)
        {
            trouve = i;
       break;
        }
        i++;
    }
    return trouve;
}

function isnewurlna(hash)
{
    var i=0;
    var trouve=-1;

    while (trouve==-1 && (i < gprcachena.length))
    {
        //dump("isnewurl: " + gprcachena[i][0] + " <?> " + hash + "\n");
        if (gprcachena[i][0] == hash)
        {
            trouve = i;
            break;
        }
        i++;
    }

   //dump(trouve + "\n");
    return trouve;
}

/************************************************************\
*
\************************************************************/
function setPagerankStatus()
{
    var pagerank = document.getElementById('pagerank-status');
    var tooltip = document.getElementById('pagerank-tooltip-value');
    var temp = gXMLHttpRequest.responseText;
    var foo = temp.match(/Rank_.*?:.*?:(\d+)/i);

    var pr = (foo) ? foo[1] : "-1";
    foo = temp.match(/A_.*?:.*?:(?:Top\/)?([^\s]+)/i);
    var cat = (foo) ? foo[1] : "n/a";
   var iscat = (cat=="n/a") ? "" : "cat";

    pagerank.setAttribute("status", iscat+pr);
    tooltip.setAttribute("value", cat);
    glastpr = pr;
    glastcat = cat;
   if (glastpr != -1)
   {
       gprcache.push(new Array(gch,glastpr));
       gcatcache.push(new Array(gch,glastcat));
   //dump("pushed: " + gch + "," + glastpr +"\n");
   }
   else
   {
      gprcachena.push(new Array(gch,glastpr));
   }
}

/************************************************************\
*
\************************************************************/
/*function URLencode(sStr) {
    return escape(sStr).replace(/\+/g, '%2B').replace(/[ ]/g,'+').replace(/\//g,'%2F').replace(/~/g,'%7E');
}
*/
function URLencode(sStr)
{
return encodeURIComponent(sStr).replace(/\+/g,"%2B").replace(/\//g,"%2F");
}
/************************************************************\
*
\************************************************************/
function initPagerankStatus()
{
    var pagerank = document.getElementById('pagerank-status');
    var tooltip = document.getElementById('pagerank-tooltip-value');

    var url = new String(window._content.document.location);
    url = url.replace(/\?.*$/g,'?');

    var reqgr = "info:" + url;
    var reqgre = "info:" + URLencode(url);
    gch = GoogleCH(strord(reqgr));
    gch = "6" + GoogleNewCh(gch);
   //dump("gch=" + gch + "\n");

    var querystring = "http://toolbarqueries.google.com/search?client=navclient-auto&ch=" + gch + "&features=Rank&q=" + reqgre;
    var patern = /^http:/;
    var patern2 = /^http:\/\/.*google\..*\/(search|images|groups|news).*/;
    var patern3 = /^http:\/\/localhost.*/;
    var patern4 = /^http:\/\/(127\.|10\.|172\.16|192\.168).*/; //local ip

    if (gstate == 0)
    {
        //pagerank.setAttribute("status", "disabled");
        //tooltip.setAttribute("value", "Disabled");
    }
    else if (!patern.test(url) || patern2.test(url)
    || patern3.test(url) || patern4.test(url))
    {
        pagerank.setAttribute("status","");
        tooltip.setAttribute("value", "n/a");
        glastpr = -1;
    }
    else if ((gisnewurl = isnewurl(gch)) >= 0)
    {
   //dump("cached: " + gprcache[gisnewurl][1] + " | " + gcatcache[gisnewurl][1] + " | ");
        glastpr = gprcache[gisnewurl][1];
        glastcat = gcatcache[gisnewurl][1];
   var iscat = (glastcat=="n/a") ? "" : "cat";
   //dump("iscat : " + iscat + " | " + iscat+glastpr);
        pagerank.setAttribute("status",iscat+glastpr);
        tooltip.setAttribute("value", glastcat);
    }
    else if ((gisnewurl = isnewurlna(gch)) >=0)
    {
        glastpr = gprcachena[gisnewurl][1];
        pagerank.setAttribute("status",glastpr);
        tooltip.setAttribute("value", "n/a");

    }
    else
    {

        gXMLHttpRequest = new XMLHttpRequest();
        gXMLHttpRequest.onload = setPagerankStatus;
        gXMLHttpRequest.open("GET", querystring);
        //gXMLHttpRequest.setRequestHeader("User-Agent","Mozilla/4.0 (compatible; GoogleToolbar 2.0.114-big; Windows XP 5.1)");
        gXMLHttpRequest.send(null);
    }
    glasturl = url;

}

/************************************************************\
*
\************************************************************/
function resetPagerankStatus()
{

    var pagerank = document.getElementById('pagerank-status');
    var tooltip = document.getElementById('pagerank-tooltip-value');
    var url = new String(window._content.document.location);

    url = url.replace(/\?.*$/g,'?');
    if (gstate == 0)
    {
        pagerank.setAttribute("status", "disabled");
        tooltip.setAttribute("value", "Disabled");
    }
    else if (url == glasturl)
    {
         var iscat = (glastcat=="n/a"||glastpr==-1) ? "" : "cat";

      pagerank.setAttribute("status", iscat+glastpr);
        if (glastpr == -1)
        tooltip.setAttribute("value", "n/a");
        else
        tooltip.setAttribute("value", glastcat);
    }
    else
    {
        glasturl = url;
        initPagerankStatus();
    }
}

/************************************************************\
*
\************************************************************/
function switchpagerankstatusstate(event)
{
    const LEFT = 0, RIGHT = 2;
    var tooltip = document.getElementById('pagerank-tooltip-value');
    var pagerank = document.getElementById('pagerank-status');

    if (event.button==RIGHT)
    {
        if (gstate == 0)
        {
            gpreferencesService.setIntPref("pagerankstatuspref.state", 1);
            gstate = 1;
            initPagerankStatus();
        }
        else
        {
            gpreferencesService.setIntPref("pagerankstatuspref.state", 0);
            gstate = 0;
            pagerank.setAttribute("status", "disabled");
            tooltip.setAttribute("value", "Disabled");
        }
    }
    else if (event.button==LEFT && gstate==1)
    {
        var gtempcat = tooltip.getAttribute("value");
//        var foo = temp.match(/Category: ([^\s]+)/i);
//        var gtempcat = (foo) ? foo[1] : "";
        gtempcat = (gtempcat=="n/a"||gtempcat=="Disabled") ? "" : gtempcat;
        if (gtempcat)
        {
            //open category page...
            var newTab = getBrowser().addTab(godpurl + encodeURI(gtempcat + "/"));
            getBrowser().selectedTab = newTab;
        }
    }
}

// prefs
var gpreferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
if(!gpreferencesService.prefHasUserValue("pagerankstatuspref.state"))
{
    gpreferencesService.setIntPref("pagerankstatuspref.state", 1);
}
if(!gpreferencesService.prefHasUserValue("pagerankstatuspref.odpurl"))
{
    gpreferencesService.setCharPref("pagerankstatuspref.odpurl", 'http://directory.google.com/Top/');
}
gstate = gpreferencesService.getIntPref("pagerankstatuspref.state");
godpurl = gpreferencesService.getCharPref("pagerankstatuspref.odpurl");
window.addEventListener("load",function() {initPagerankStatus();},true);
window.addEventListener("focus",function() {resetPagerankStatus();},true);

//***********
//debug  dump() to stdout (firefox -console)?
/*
const PREFS_CID      = "@mozilla.org/preferences;1";
const PREFS_I_PREF   = "nsIPref";
const PREF_STRING    = "browser.dom.window.dump.enabled";
try {
        var Pref        = new Components.Constructor(PREFS_CID, PREFS_I_PREF);
        var pref        = new Pref( );
        pref.SetBoolPref(PREF_STRING, true);
} catch(e) {} */
//************

